﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace YOYO_GUI1 {
    public partial class Form1 : Form {

        byte[,] k = new byte[4, 4]; List<byte[,]> rk = new List<byte[,]>();
        byte[,] candK = new byte[4, 4]; List<byte[,]> candRK = new List<byte[,]>();
        byte[,] p1 = new byte[4, 4]; byte[,] p2 = new byte[4, 4]; byte[,] p1_ = new byte[4, 4]; byte[,] p2_ = new byte[4, 4];
        byte[,] c1 = new byte[4, 4]; byte[,] c2 = new byte[4, 4]; byte[,] c1_ = new byte[4, 4]; byte[,] c2_ = new byte[4, 4];
        byte[,] p1_cand = new byte[4, 4]; byte[,] p2_cand = new byte[4, 4]; byte[,] c1_cand = new byte[4, 4]; byte[,] c2_cand = new byte[4, 4];
        byte[,] xp1p2_cand = new byte[4, 4];
        byte[,] p1xp2 = new byte[4, 4]; byte[,] p1_xp2_ = new byte[4, 4]; byte[,] c1xc2 = new byte[4, 4]; byte[,] c1_xc2_ = new byte[4, 4];
        byte[,] a1 = new byte[4, 4]; byte[,] a2 = new byte[4, 4]; byte[,] a1_ = new byte[4, 4]; byte[,] a2_ = new byte[4, 4];
        byte[,] b1 = new byte[4, 4]; byte[,] b2 = new byte[4, 4]; byte[,] b1_ = new byte[4, 4]; byte[,] b2_ = new byte[4, 4];
        byte[,] a1xa2 = new byte[4, 4]; byte[,] a1_xa2_ = new byte[4, 4]; byte[,] b1xb2 = new byte[4, 4]; byte[,] b1_xb2_ = new byte[4, 4];
        byte[] v = new byte[4] { 1, 0, 0, 0 };
        byte[,] state1 = new byte[4, 4]; byte[,] state2 = new byte[4, 4]; byte[,] statex = new byte[4, 4];
        byte[,] x = new byte[4, 4];
        Rijndael aes = new Rijndael();

        bool k0 = true;
        bool k1 = true;
        bool k2 = true;
        bool k3 = true;
        bool k4 = true;
        bool k5 = true;
        bool k6 = true;
        bool k7 = true;
        bool k8 = true;
        bool k9 = true;
        bool kA = true;
        bool kB = true;
        bool kC = true;
        bool kD = true;
        bool kE = true;
        bool kF = true;

        bool v0 = true; bool v1 = false; bool v2 = false; bool v3 = false;

        public Form1() {
            InitializeComponent();
            state1 = aes.StringTo4x4ByteArray(textBoxState1.Text.ToString()); tbState1.Text = Display(state1);
            state2 = aes.StringTo4x4ByteArray(textBoxState2.Text.ToString()); tbState2.Text = Display(state2);
        }

        private string Display(byte[,] a) {
            string s = "";
            for (int i = 0; i < 4; i++) {
                for (int j = 0; j < 4; j++) {
                    s += a[i, j].ToString("X").PadLeft(2, '0').ToUpper() + " ";
                }
                s += "\r\n";
            }
            return s;
        }

        

        private void btnEnc1_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);                        

            c1 = aes.Enc(p1, rk, 1); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 1); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);
            
            b1 = aes.Enc(a1, candRK, 1); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 1); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc2_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Enc(p1, rk, 2); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 2); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Enc(a1, candRK, 2); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 2); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc3_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Enc(p1, rk, 3); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 3); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Enc(a1, candRK, 3); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 3); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc4_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Enc(p1, rk, 4); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 4); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Enc(a1, candRK, 4); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 4); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc5_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Enc(p1, rk, 5); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 5); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Enc(a1, candRK, 5); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 5); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc6_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Enc(p1, rk, 6); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 6); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Enc(a1, candRK, 6); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 6); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc7_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Enc(p1, rk, 7); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 7); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Enc(a1, candRK, 7); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 7); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc8_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Enc(p1, rk, 8); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 8); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Enc(a1, candRK, 8); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 8); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc9_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Enc(p1, rk, 9); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 9); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Enc(a1, candRK, 9); tbB1.Text = Display(b1);
            b2 = aes.Enc(a2, candRK, 9); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }
        private void btnEnc10_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            c1 = aes.Encrypt(p1, rk); tbC1.Text = Display(c1);
            c2 = aes.Encrypt(p2, rk); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);

            b1 = aes.Encrypt(a1, candRK); tbB1.Text = Display(b1);
            b2 = aes.Encrypt(a2, candRK); tbB2.Text = Display(b2);
            a1xa2 = aes.XOR(a1, a2); tbA1xA2.Text = Display(a1xa2);
            b1xb2 = aes.XOR(b1, b2); tbB1xB2.Text = Display(b1xb2);

            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }


        private void btnPvC_Click(object sender, EventArgs e) {
            c1_ = aes.PvC(c1, c2, v); tbC1_.Text = Display(c1_);
            c2_ = aes.PvC(c2, c1, v); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.PvC(b1, b2, v); tbB1_.Text = Display(b1_);
            b2_ = aes.PvC(b2, b1, v); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.PvC(c1, c2, v); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.PvC(c2, c1, v); tbC2_cand.Text = Display(c2_cand);
        }
        private void btnPvD_Click(object sender, EventArgs e) {
            c1_ = aes.PvD(c1, c2, v); tbC1_.Text = Display(c1_);
            c2_ = aes.PvD(c2, c1, v); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.PvD(b1, b2, v); tbB1_.Text = Display(b1_);
            b2_ = aes.PvD(b2, b1, v); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.PvD(c1, c2, v); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.PvD(c2, c1, v); tbC2_cand.Text = Display(c2_cand);

        }
        private void btnPvM_Click(object sender, EventArgs e) {
            c1_ = aes.PvM3(c1, c2, v); tbC1_.Text = Display(c1_);
            c2_ = aes.PvM3(c2, c1, v); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.PvM3(b1, b2, v); tbB1_.Text = Display(b1_);
            b2_ = aes.PvM3(b2, b1, v); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.PvM3(c1, c2, v); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.PvM3(c2, c1, v); tbC2_cand.Text = Display(c2_cand);
        }
        private void btnPvL_Click(object sender, EventArgs e) {
            c1_ = aes.Pv45(c1, c2, v, rk); tbC1_.Text = Display(c1_);
            c2_ = aes.Pv45(c2, c1, v, rk); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.Pv45(b1, b2, v, candRK); tbB1_.Text = Display(b1_);
            b2_ = aes.Pv45(b2, b1, v, candRK); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.Pv44(c1, c2, v, candRK); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.Pv44(c2, c1, v, candRK); tbC2_cand.Text = Display(c2_cand);
        }
        private void btnPv5_Click(object sender, EventArgs e) {
            c1_ = aes.Pv52(c1, c2, v, rk); tbC1_.Text = Display(c1_);
            c2_ = aes.Pv52(c2, c1, v, rk); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.Pv52(b1, b2, v, candRK); tbB1_.Text = Display(b1_);
            b2_ = aes.Pv52(b2, b1, v, candRK); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.Pv52(c1, c2, v, candRK); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.Pv52(c2, c1, v, candRK); tbC2_cand.Text = Display(c2_cand);
        }
        private void btnPv6_Click(object sender, EventArgs e) {
            c1_ = aes.Pv6(c1, c2, v, rk); tbC1_.Text = Display(c1_);
            c2_ = aes.Pv6(c2, c1, v, rk); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.Pv6(b1, b2, v, candRK); tbB1_.Text = Display(b1_);
            b2_ = aes.Pv6(b2, b1, v, candRK); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.Pv6(c1, c2, v, candRK); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.Pv6(c2, c1, v, candRK); tbC2_cand.Text = Display(c2_cand);
        }
        private void btnPv7_Click(object sender, EventArgs e) {
            c1_ = aes.Pv7(c1, c2, v, rk); tbC1_.Text = Display(c1_);
            c2_ = aes.Pv7(c2, c1, v, rk); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.Pv7(b1, b2, v, candRK); tbB1_.Text = Display(b1_);
            b2_ = aes.Pv7(b2, b1, v, candRK); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.Pv7(c1, c2, v, candRK); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.Pv7(c2, c1, v, candRK); tbC2_cand.Text = Display(c2_cand);
        }
        private void btnPv8_Click(object sender, EventArgs e) {
            c1_ = aes.Pv8(c1, c2, v, rk); tbC1_.Text = Display(c1_);
            c2_ = aes.Pv8(c2, c1, v, rk); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.Pv8(b1, b2, v, candRK); tbB1_.Text = Display(b1_);
            b2_ = aes.Pv8(b2, b1, v, candRK); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.Pv8(c1, c2, v, candRK); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.Pv8(c2, c1, v, candRK); tbC2_cand.Text = Display(c2_cand);
        }
        private void btnPv9_Click(object sender, EventArgs e) {
            c1_ = aes.Pv9(c1, c2, v, rk); tbC1_.Text = Display(c1_);
            c2_ = aes.Pv9(c2, c1, v, rk); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.Pv9(b1, b2, v, candRK); tbB1_.Text = Display(b1_);
            b2_ = aes.Pv9(b2, b1, v, candRK); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.Pv9(c1, c2, v, candRK); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.Pv9(c2, c1, v, candRK); tbC2_cand.Text = Display(c2_cand);
        }
        private void btnPv10_Click(object sender, EventArgs e) {
            c1_ = aes.Pv103(c1, c2, v, rk); tbC1_.Text = Display(c1_); tbCmagisk1.Text = Display(c1_);
            c2_ = aes.Pv103(c2, c1, v, rk); tbC2_.Text = Display(c2_); tbCmagisk2.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.Pv103(b1, b2, v, candRK); tbB1_.Text = Display(b1_);
            b2_ = aes.Pv103(b2, b1, v, candRK); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_);

            c1_cand = aes.Pv103(c1, c2, v, candRK); tbC1_cand.Text = Display(c1_cand);
            c2_cand = aes.Pv103(c2, c1, v, candRK); tbC2_cand.Text = Display(c2_cand);
        }

        private void btnFun4_Click(object sender, EventArgs e) {
            c1_ = aes.StringTo4x4ByteArray("E6B1478AE3A002D2E823C33CB35FA9AC"); tbC1_.Text = Display(c1_);
            c2_ = aes.StringTo4x4ByteArray("56EB2C9FE394C0D7803F7481BE461DCF"); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            b1_ = aes.copy(c1_); tbB1_.Text = Display(b1_);
            b2_ = aes.copy(c2_); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(b1_, b2_); tbB1_xB2_.Text = Display(b1_xb2_); 
        }
        

        private void btnDec1_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 1); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 1); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 1); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 1); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 1); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 1); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec2_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 2); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 2); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 2); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 2); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 2); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 2); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec3_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 3); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 3); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 3); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 3); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 3); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 3); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec4_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 4); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 4); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 4); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 4); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 4); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 4); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec5_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 5); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 5); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 5); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 5); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 5); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 5); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec6_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 6); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 6); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 6); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 6); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 6); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 6); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec7_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 7); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 7); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 7); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 7); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 7); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 7); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec8_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 8); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 8); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 8); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 8); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 8); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 8); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec9_Click(object sender, EventArgs e) {
            p1_ = aes.Dec(c1_, rk, 9); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Dec(c2_, rk, 9); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p1_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Dec(b1_, candRK, 9); tbA1_.Text = Display(a1_);
            a2_ = aes.Dec(b2_, candRK, 9); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Dec(c1_cand, rk, 9); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Dec(c2_cand, rk, 9); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);

            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }
        private void btnDec10_Click(object sender, EventArgs e) {
            p1_ = aes.Decrypt(c1_, rk); tbP1_.Text = Display(p1_); textBoxMagic1.Text = aes.ToString(p1_);
            p2_ = aes.Decrypt(c2_, rk); tbP2_.Text = Display(p2_); textBoxMagic2.Text = aes.ToString(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            a1_ = aes.Decrypt(b1_, candRK); tbA1_.Text = Display(a1_);
            a2_ = aes.Decrypt(b2_, candRK); tbA2_.Text = Display(a2_);
            a1_xa2_ = aes.XOR(a1_, a2_); tbA1_xA2_.Text = Display(a1_xa2_);

            p1_cand = aes.Decrypt(c1_cand, rk); tbP1_cand.Text = Display(p1_cand);
            p2_cand = aes.Decrypt(c2_cand, rk); tbP2_cand.Text = Display(p2_cand);
            xp1p2_cand = aes.XOR(p1_cand, p2_cand); tbxP1P2_cand.Text = Display(xp1p2_cand);
            
            x = aes.XOR(p1_xp2_, a1_xa2_); tbX.Text = Display(x);
            if (aes.IsTheSame(p1_xp2_, a1_xa2_)) { labelSame1.ForeColor = Color.GreenYellow; labelSame2.ForeColor = Color.GreenYellow; }
            else { labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black; }
        }

        private void btnDecryptMagisk_Click(object sender, EventArgs e) {
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);
            byte[,] pMagisk1 = aes.Decrypt(c1_, candRK); tbPmagisk1.Text = Display(pMagisk1);
            byte[,] pMagisk2 = aes.Decrypt(c2_, candRK); tbPmagisk2.Text = Display(pMagisk2);
            byte[,] xMagisk = aes.XOR(pMagisk1, pMagisk2); tbPxPmagisk.Text = Display(xMagisk);
                                    
        }

        private void btn0_Click(object sender, EventArgs e) { textBoxP2.Text = "AA111111111111111111111111111111"; }
        private void btn1_Click(object sender, EventArgs e) { textBoxP2.Text = "11AA1111111111111111111111111111"; }
        private void btn2_Click(object sender, EventArgs e) { textBoxP2.Text = "1111AA11111111111111111111111111"; }
        private void btn3_Click(object sender, EventArgs e) { textBoxP2.Text = "111111AA111111111111111111111111"; }
        private void btn4_Click(object sender, EventArgs e) { textBoxP2.Text = "11111111AA1111111111111111111111"; }
        private void btn5_Click(object sender, EventArgs e) { textBoxP2.Text = "1111111111AA11111111111111111111"; }
        private void btn6_Click(object sender, EventArgs e) { textBoxP2.Text = "111111111111AA111111111111111111"; }
        private void btn7_Click(object sender, EventArgs e) { textBoxP2.Text = "11111111111111AA1111111111111111"; }
        private void btn8_Click(object sender, EventArgs e) { textBoxP2.Text = "1111111111111111AA11111111111111"; }
        private void btn9_Click(object sender, EventArgs e) { textBoxP2.Text = "111111111111111111AA111111111111"; }
        private void btnA_Click(object sender, EventArgs e) { textBoxP2.Text = "11111111111111111111AA1111111111"; }
        private void btnB_Click(object sender, EventArgs e) { textBoxP2.Text = "1111111111111111111111AA11111111"; }
        private void btnC_Click(object sender, EventArgs e) { textBoxP2.Text = "111111111111111111111111AA111111"; }
        private void btnD_Click(object sender, EventArgs e) { textBoxP2.Text = "11111111111111111111111111AA1111"; }
        private void btnE_Click(object sender, EventArgs e) { textBoxP2.Text = "1111111111111111111111111111AA11"; }
        private void btnF_Click(object sender, EventArgs e) { textBoxP2.Text = "111111111111111111111111111111AA"; }

        private void btnClear_Click(object sender, EventArgs e) {
            tbP1_.Clear(); tbP2_.Clear(); tbP1_xP2_.Clear();
            tbC1.Clear(); tbC1_.Clear(); tbC2.Clear(); tbC2_.Clear(); tbC1xC2.Clear(); tbC1_xC2_.Clear();
            tbA1_.Clear(); tbA2_.Clear(); tbA1_xA2_.Clear();
            tbB1.Clear(); tbB1_.Clear(); tbB2.Clear(); tbB2_.Clear(); tbB1xB2.Clear(); tbB1_xB2_.Clear();
        }
        private void btnK0_Click(object sender, EventArgs e) {
            if (k0) { candK[0, 0] = 0x99; k0 = false; }
            else { candK[0, 0] = 0x00; k0 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK1_Click(object sender, EventArgs e) {
            if (k1) { candK[1, 0] = 0x11; k1 = false; }
            else { candK[1, 0] = 0x00; k1 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK2_Click(object sender, EventArgs e) {
            if (k2) { candK[2, 0] = 0x22; k2 = false; }
            else { candK[2, 0] = 0x00; k2 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK3_Click(object sender, EventArgs e) {
            if (k3) { candK[3, 0] = 0x33; k3 = false; }
            else { candK[3, 0] = 0x00; k3 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK4_Click(object sender, EventArgs e) {
            if (k4) { candK[0, 1] = 0x44; k4 = false; }
            else { candK[0, 1] = 0x00; k4 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK5_Click(object sender, EventArgs e) {
            if (k5) { candK[1, 1] = 0x55; k5 = false; }
            else { candK[1, 1] = 0x00; k5 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK6_Click(object sender, EventArgs e) {
            if (k6) { candK[2, 1] = 0x66; k6 = false; }
            else { candK[2, 1] = 0x00; k6 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK7_Click(object sender, EventArgs e) {
            if (k7) { candK[3, 1] = 0x77; k7 = false; }
            else { candK[3, 1] = 0x00; k7 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK8_Click(object sender, EventArgs e) {
            if (k8) { candK[0, 2] = 0x88; k8 = false; }
            else { candK[0, 2] = 0x00; k8 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnK9_Click(object sender, EventArgs e) {
            if (k9) { candK[1, 2] = 0x99; k9 = false; }
            else { candK[1, 2] = 0x00; k9 = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnKA_Click(object sender, EventArgs e) {
            if (kA) { candK[2, 2] = 0xAA; kA = false; }
            else { candK[2, 2] = 0x00; kA = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnKB_Click(object sender, EventArgs e) {
            if (kB) { candK[3, 2] = 0xBB; kB = false; }
            else { candK[3, 2] = 0x00; kB = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnKC_Click(object sender, EventArgs e) {
            if (kC) { candK[0, 3] = 0xCC; kC = false; }
            else { candK[0, 3] = 0x00; kC = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnKD_Click(object sender, EventArgs e) {
            if (kD) { candK[1, 3] = 0xDD; kD = false; }
            else { candK[1, 3] = 0x00; kD = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnKE_Click(object sender, EventArgs e) {
            if (kE) { candK[2, 3] = 0xEE; kE = false; }
            else { candK[2, 3] = 0x00; kE = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }
        private void btnKF_Click(object sender, EventArgs e) {
            if (kF) { candK[3, 3] = 0xFF; kF = false; }
            else { candK[3, 3] = 0x00; kF = true; }
            textBoxcandK.Text = aes.ToString(candK);
        }



        private void btnV0_Click(object sender, EventArgs e) {
            if (v0 == false) { v[0] = 1; v0 = true; }
            else { v[0] = 0; v0 = false; }
            btnV0.Text = v[0].ToString();
        }
        private void btnV1_Click(object sender, EventArgs e) {
            if (v1 == false) { v[1] = 1; v1 = true; }
            else { v[1] = 0; v1 = false; }
            btnV1.Text = v[1].ToString();
        }
        private void btnV2_Click(object sender, EventArgs e) {
            if (v2 == false) { v[2] = 1; v2 = true; }
            else { v[2] = 0; v2 = false; }
            btnV2.Text = v[2].ToString();
        }
        private void btnV3_Click(object sender, EventArgs e) {
            if (v3 == false) { v[3] = 1; v3 = true; }
            else { v[3] = 0; v3 = false; }
            btnV3.Text = v[3].ToString();
        }

        private void btnSB_Click(object sender, EventArgs e) {
            state1 = aes.StringTo4x4ByteArray(textBoxState1.Text.ToString());
            state2 = aes.StringTo4x4ByteArray(textBoxState2.Text.ToString());
            state1 = aes.SB(state1); tbState1.Text = Display(state1); textBoxState1.Text = aes.ToString(state1);
            state2 = aes.SB(state2); tbState2.Text = Display(state2); textBoxState2.Text = aes.ToString(state2);
            statex = aes.XOR(state1, state2); tbStateX.Text = Display(statex);
        }
        private void btnSR_Click(object sender, EventArgs e) {
            state1 = aes.StringTo4x4ByteArray(textBoxState1.Text.ToString());
            state2 = aes.StringTo4x4ByteArray(textBoxState2.Text.ToString());
            state1 = aes.SR(state1); tbState1.Text = Display(state1); textBoxState1.Text = aes.ToString(state1);
            state2 = aes.SR(state2); tbState2.Text = Display(state2); textBoxState2.Text = aes.ToString(state2);
            statex = aes.XOR(state1, state2); tbStateX.Text = Display(statex);
        }
        private void btnMC_Click(object sender, EventArgs e) {
            state1 = aes.StringTo4x4ByteArray(textBoxState1.Text.ToString());
            state2 = aes.StringTo4x4ByteArray(textBoxState2.Text.ToString());
            state1 = aes.MC(state1); tbState1.Text = Display(state1); textBoxState1.Text = aes.ToString(state1);
            state2 = aes.MC(state2); tbState2.Text = Display(state2); textBoxState2.Text = aes.ToString(state2);
            statex = aes.XOR(state1, state2); tbStateX.Text = Display(statex);
        }
        private void btnSBi_Click(object sender, EventArgs e) {
            state1 = aes.StringTo4x4ByteArray(textBoxState1.Text.ToString());
            state2 = aes.StringTo4x4ByteArray(textBoxState2.Text.ToString());
            state1 = aes.SBi(state1); tbState1.Text = Display(state1); textBoxState1.Text = aes.ToString(state1);
            state2 = aes.SBi(state2); tbState2.Text = Display(state2); textBoxState2.Text = aes.ToString(state2);
            statex = aes.XOR(state1, state2); tbStateX.Text = Display(statex);
        }
        private void btnSRi_Click(object sender, EventArgs e) {
            state1 = aes.StringTo4x4ByteArray(textBoxState1.Text.ToString());
            state2 = aes.StringTo4x4ByteArray(textBoxState2.Text.ToString());
            state1 = aes.SRi(state1); tbState1.Text = Display(state1); textBoxState1.Text = aes.ToString(state1);
            state2 = aes.SRi(state2); tbState2.Text = Display(state2); textBoxState2.Text = aes.ToString(state2);
            statex = aes.XOR(state1, state2); tbStateX.Text = Display(statex);
        }
        private void btnMCi_Click(object sender, EventArgs e) {
            state1 = aes.StringTo4x4ByteArray(textBoxState1.Text.ToString());
            state2 = aes.StringTo4x4ByteArray(textBoxState2.Text.ToString());
            state1 = aes.MCi(state1); tbState1.Text = Display(state1); textBoxState1.Text = aes.ToString(state1);
            state2 = aes.MCi(state2); tbState2.Text = Display(state2); textBoxState2.Text = aes.ToString(state2);
            statex = aes.XOR(state1, state2); tbStateX.Text = Display(statex);
        }

        private void btnMagic_Click(object sender, EventArgs e) {
            p1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbP1.Text = Display(p1);
            p2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbP2.Text = Display(p2);
            a1 = aes.StringTo4x4ByteArray(textBoxP1.Text.ToString()); tbA1.Text = Display(a1);
            a2 = aes.StringTo4x4ByteArray(textBoxP2.Text.ToString()); tbA2.Text = Display(a2);
            k = aes.StringTo4x4ByteArray(textBoxK.Text.ToString()); rk = aes.KeySchedule(k);
            candK = aes.StringTo4x4ByteArray(textBoxcandK.Text.ToString()); candRK = aes.KeySchedule(candK);

            
            c1 = aes.Enc(p1, rk, 1); tbC1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 1); tbC2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);
            c1_ = aes.PvD(c1, c2, v); tbC1_.Text = Display(c1_);
            c2_ = aes.PvD(c2, c1, v); tbC2_.Text = Display(c2_);
            c1_xc2_ = aes.XOR(c1_, c2_); tbC1_xC2_.Text = Display(c1_xc2_);

            


            p1_ = aes.Dec(c1_, rk, 1); tbP1_.Text = Display(p1_);
            p2_ = aes.Dec(c2_, rk, 1); tbP2_.Text = Display(p2_);
            p1_xp2_ = aes.XOR(p1_, p2_); tbP1_xP2_.Text = Display(p1_xp2_);

            

            byte[,] c4Magic1 = aes.Enc(p1_, rk, 4); tbC1_.Text = Display(c4Magic1);
            byte[,] c4Magic2 = aes.Enc(p2_, rk, 4); tbC2_.Text = Display(c4Magic2);
            c1_xc2_ = aes.XOR(c4Magic1, c4Magic2); tbC1_xC2_.Text = Display(c1_xc2_);

            c1 = aes.Enc(p1, rk, 4); tbC1.Text = Display(c1); textBoxState1.Text = aes.ToString(c1); tbState1.Text = Display(c1);
            c2 = aes.Enc(p2, rk, 4); tbC2.Text = Display(c2); textBoxState2.Text = aes.ToString(c2); tbState2.Text = Display(c2);
            p1xp2 = aes.XOR(p1, p2); tbP1xP2.Text = Display(p1xp2);
            c1xc2 = aes.XOR(c1, c2); tbC1xC2.Text = Display(c1xc2);


            b1_ = aes.copy(c4Magic1); tbB1_.Text = Display(b1_);
            b2_ = aes.copy(c4Magic2); tbB2_.Text = Display(b2_);
            b1_xb2_ = aes.XOR(c4Magic1, c4Magic2); tbB1_xB2_.Text = Display(b1_xb2_);

            byte[,] pMagic1 = aes.Dec(c4Magic1, candRK, 4); tbA1_.Text = Display(pMagic1);
            byte[,] pMagic2 = aes.Dec(c4Magic2, candRK, 4); tbA2_.Text = Display(pMagic2);
            byte[,] xMagic = aes.XOR(pMagic1, pMagic2); tbA1_xA2_.Text = Display(xMagic);


            labelSame1.ForeColor = Color.Black; labelSame2.ForeColor = Color.Black;
        }

        private void pvYo_Click(object sender, EventArgs e) {
            byte[,] a = aes.StringTo4x4ByteArray(textBoxState1.Text.ToString());
            byte[,] b = aes.StringTo4x4ByteArray(textBoxState2.Text.ToString());

            byte[,] pvYo = aes.PvYo(a, b, v);
            tbStateX.Text = Display(pvYo);
        }

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        

        


    }
}
